#define AVOID_BUG1

#include <boost/container/map.hpp>
#include <boost/container/vector.hpp>

#if !defined(AVOID_BUG1)
namespace bug1 {

struct no_operator { };

// this class allows implicit conversions and makes the following operator
// definition less-preferred than any other such operators that might be found
// via argument-dependent name lookup
struct any { template <class T> any(T const&); };

// when operator BOOST_TT_TRAIT_OP is not available, this one is used
no_operator operator && (const any&, const any&);

} // bug1
#endif

namespace cont = boost::container;

typedef cont::multimap<int,int> Map;
typedef Map::const_iterator T;
typedef cont::vector<T> V;

void f()
{
    V v;
    T t = T();
    v.push_back(t);
}
